com.pivotal.gemfirexd.internal.client.am.stmtcache

## Class StatementKeyFactory

- java.lang.Object
- - com.pivotal.gemfirexd.internal.client.am.stmtcache.StatementKeyFactory

    public final class StatementKeyFactory
    extends Object

A factory for creating JDBC statement keys for use with the JDBC statement cache.

See Also:
  `JDBCStatementCache`

### Method Summary

Methods
`static StatementKey` `newCallable(String sql, String schema, int holdability)` Creates a key for a callable statement.
`static StatementKey` `newCallable(String sql, String schema, int rst, int rsc, int rsh)` Creates a key for a callable statement specifying result set type and concurrency.
`static StatementKey` `newPrepared(String sql, String schema, int holdability)` Creates a key for a query with default settings.
`static StatementKey` `newPrepared(String sql, String schema, int holdability, int autogeneratedKeys)` Creates a key for a query specifying whether auto-generated keys shall be returned.
`static StatementKey` `newPrepared(String sql, String schema, int rst, int rsc, int rsh)` Creates a key for a query specifying result set type and concurrency.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### newPrepared

    public static StatementKey newPrepared(String sql,
                           String schema,
                           int holdability)

Creates a key for a query with default settings.

Defaults are according to the JDBC standard; result set type will be `ResultSet.TYPE_FORWARD_ONLY`, concurrency will be `ResultSet.CONCUR_READ_ONLY` and the statement will not return auto-generated keys.

Parameters:
  `sql` - SQL query string
  `schema` - current compilation schema
  `holdability` - result set holdability
Returns:
  A statement key.

#### newPrepared

    public static StatementKey newPrepared(String sql,
                           String schema,
                           int holdability,
                           int autogeneratedKeys)

Creates a key for a query specifying whether auto-generated keys shall be returned.

Unspecified settings will be according to the JDBC standard; result set type will be `ResultSet.TYPE_FORWARD_ONLY`, concurrency will be `ResultSet.CONCUR_READ_ONLY`.

Parameters:
  `sql` - SQL query string
  `schema` - current compilation schema
  `holdability` - result set holdability
  `autogeneratedKeys` - tells whether or not to reutrn auto-generated keys
Returns:
  A statement key.

#### newPrepared

    public static StatementKey newPrepared(String sql,
                           String schema,
                           int rst,
                           int rsc,
                           int rsh)

Creates a key for a query specifying result set type and concurrency.

The returned key is for a statement not returning auto-generated keys.

Parameters:
  `sql` - SQL query string
  `schema` - current compilation schema
  `rst` - result set type
  `rsc` - result set concurrency level
  `rsh` - result set holdability
Returns:
  A statement key.

#### newCallable

    public static StatementKey newCallable(String sql,
                           String schema,
                           int holdability)

Creates a key for a callable statement.

Unspecified settings will be according to the JDBC standard; result set type will be `ResultSet.TYPE_FORWARD_ONLY`, concurrency will be `ResultSet.CONCUR_READ_ONLY`.

Parameters:
  `sql` - SQL query string
  `schema` - current compilation schema
  `holdability` - result set holdability
Returns:
  A statement key.

#### newCallable

    public static StatementKey newCallable(String sql,
                           String schema,
                           int rst,
                           int rsc,
                           int rsh)

Creates a key for a callable statement specifying result set type and concurrency.

The returned key is for a statement not returning auto-generated keys.

Parameters:
  `sql` - SQL query string
  `schema` - current compilation schema
  `rst` - result set type
  `rsc` - result set concurrency level
  `rsh` - result set holdability
Returns:
  A statement key.